#!/usr/bin/env python

import sys
import Numeric
import FBF

ERROR_MARGIN = 0.01

def verify( infile, outfile, reffile):
    infbf = FBF.FBF(infile)
    outfbf = FBF.FBF(outfile)
    reffbf = FBF.FBF(reffile)
    
    numerr = 0
    for i in range( 1, infbf.length() + 1 ):
        ind = infbf.read(i)
        outd = outfbf.read(i)
        refd = reffbf.read(i)
        
        if (outd - ind - Numeric.ones(infbf.grouping[0], 'd')) > ERROR_MARGIN:
            if not numerr:
                print outd - ind
            numerr += 1
    print "%s errors" % numerr
    
    infbf.close()
    outfbf.close()
    reffbf.close()
        
if __name__ == '__main__':
    verify(sys.argv[1], sys.argv[2], sys.argv[3])