function F = fmatrix( N, ratio, outfile )
% F = fmatrix( N, ratio, outfile-optional )
%
% Compute the matrix F.  Note that this should be precomputed 
% for each distinct value of off-axis angles theta and stored in 
% memory.
k = (N/2:N)';
k2 = repmat(k,1,floor(N/2)+1);
x = k2'*ratio - k2;
F = ratio * sinc(x)./sinc(x/N);

if nargin>2
    s = size(F);
    fname = sprintf( '%s.real8.%d.%d', outfile, s(1), s(2) )
    fp = fopen( fname, 'wb', 'l' );
    fwrite( fp, reshape( F, s(1)*s(2), 1 ), 'real*8' );
    fclose(fp);
end
return 


function s = sinc(x)
    z = (x==0);
    nz = (x~=0);
    s = pi*x;
    s(z)=1.0;
    s(nz)=sin(s(nz)) ./ s(nz); 

