static const char _cvsid[] = 
"$Id: clok.cc,v 1.6 2004/03/16 16:11:27 rayg Exp $";
#include <string>
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include "assert.h"

#include "clok.h"

std::string clok::report() const { 
    char buffer[ 80 ];
    sprintf( buffer, "n %d wall %8g user %8g sys %8g", n, w, u, s );
    return std::string( buffer );
}

void clok::wall( double &wall ) {
        struct timeval tv;
        struct timezone tz;
        assert( sizeof(time_t)==sizeof(int) );
        gettimeofday( &tv, &tz );
        wall = (double)tv.tv_sec + ((double)tv.tv_usec)/1e6;
}

void clok::user_sys( double &user, double &sys ) {
        struct rusage usage;
        getrusage( RUSAGE_SELF, &usage );
        user = (double)usage.ru_utime.tv_sec + ((double)usage.ru_utime.tv_usec)/1e6;
        sys = (double)usage.ru_stime.tv_sec + ((double)usage.ru_stime.tv_usec)/1e6;
} 


