#ifndef H_CLOK
#define H_CLOK
//
// A simple stopwatch class for performance measurements
//
#include <string>

class clok { 
    int n;
    double 
        w,u,s, // accumulated totals 
        sw,su,ss; // start times
public:
    clok(): n(0), w(0.), u(0.), s(0.), sw(0.), su(0.), ss(0.) { }
    static void wall( double & ); 
    static void user_sys( double &, double & ); 
    inline void start() { n++; wall(sw); user_sys(su,ss); }
    inline void stop() { double ew, eu, es; wall(ew); user_sys(eu,es); w += ew-sw; u += eu-su; s += es-ss; }
    std::string report() const;
    inline void result( int &N, double &W, double &U, double &S ) const { 
        N=n; W=w; U=u; S=s;
    }
    inline void mean( double &W, double &U, double &S ) const { 
        double N(n);
        W = w/N; U = u/N; S = s/N;
    }
    inline void reset() { n = 0; w = u = s = sw = su = ss = 0.; }
};

#endif
