
#include <string>
#include <map>
#include "clok.h"

#ifdef __GNUC__
#define FORTRAN(x) x##__
#else
#define FORTRAN(x) x##_
#endif

static std::map< int, clok, std::less<int> > clox;

extern "C" { 
void FORTRAN(clokon)( const int *id ); // start a stopwatch
void FORTRAN(clokoff)( const int *id ); // stop a stopwatch
void FORTRAN(clokrst)( const int *id ); // reset a stopwatch
void FORTRAN(clokres)( const int *id, int *n, double *w, double *u, double *s );
   // retrieve wall, user, system time in seconds
void FORTRAN(clokrac)( const int *id, double *w, double *u, double *s );
   // accumulate wall, user, system time
};

void FORTRAN(clokon)( const int *id ) {
    clok &it( clox[*id] );
    it.start();
}

void FORTRAN(clokoff)( const int *id ) {
    clok &it( clox[*id] );
    it.stop();
}

void FORTRAN(clokrst)( const int *id ) {
    clok &it( clox[*id] );
    it.reset();
}

void FORTRAN(clokres)( const int *id, int *n, double *w, double *u, double *s ) {
    clok &it( clox[*id] );
    it.result( *n, *w, *u, *s );
}

void FORTRAN(clokrac)( const int *id, double *w, double *u, double *s ) {
    clok &it( clox[*id] );
    int n;
    double ww, uu, ss;
    it.result( n, ww, uu, ss );
    *w += ww; *u += uu; *s += ss;
}
